unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, Dxcore,
  activex;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_WJGMDList, U_WJGCKOutList, U_WJGCKKCList, U_DJBRKList,
  U_DJBCKOutList, U_DJBCKKCList, U_DJBCKKCHZList, U_WJGCKKCHZList, U_SXCKNewList,
  U_SXCKOutList, U_PBCKKCList, U_ShaRKList, U_ShaOutList, U_ShaKCList,
  U_HCSHList, U_CKProductBSCRCList, U_WJGCKKCHZList2, U_PBCKKCHZList3,
  U_DJBRKList2;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '47.103.218.212,7781';
//  server := '.';
  dtbase := 'guhangdata';
  user := 'sa';
  pswd := 'rightsoft@123';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;

//   DName:='熊力';
//   DParameters1:='高权限';
//   DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    999:  //生产损耗管理
      begin
        if frmHCSHList = nil then
        begin
          frmHCSHList := TfrmHCSHList.Create(application.MainForm);
          with frmHCSHList do
          begin
            caption := Trim(Title);
            canshu1 := '管理';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmHCSHList.BringToFront;
       //句柄
        mnewHandle := frmHCSHList.Handle;
      end;
    11:  //纱线入库
      begin
        if frmShaRKList <> nil then
          frmShaRKList.Free;
        if frmShaRKList = nil then
        begin
          frmShaRKList := TfrmShaRKList.Create(application.MainForm);
          with frmShaRKList do
          begin
            caption := Trim(Title);
            fckName := trim(DParameters3);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKList.BringToFront;
       //句柄
        mnewHandle := frmShaRKList.Handle;
      end;
    12:  //纱线出库
      begin
        if frmShaOutList <> nil then
          frmShaOutList.Free;
        if frmShaOutList = nil then
        begin
          frmShaOutList := TfrmShaOutList.Create(application.MainForm);
          with frmShaOutList do
          begin
            caption := Trim(Title);
          //  fckName := trim(DParameters3);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutList.BringToFront;
       //句柄
        mnewHandle := frmShaOutList.Handle;
      end;
    13:  //纱线库存
      begin
        if frmShaKCList <> nil then
          frmShaKCList.Free;
        if frmShaKCList = nil then
        begin
          frmShaKCList := TfrmShaKCList.Create(application.MainForm);
          with frmShaKCList do
          begin
            caption := Trim(Title);
           // fckName := trim(DParameters3);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaKCList.BringToFront;
       //句柄
        mnewHandle := frmShaKCList.Handle;
      end;
    111:  //坯布入库
      begin
        if frmSXCKNewList = nil then
        begin
          frmSXCKNewList := TfrmSXCKNewList.Create(application.MainForm);
          with frmSXCKNewList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSXCKNewList.BringToFront;
       //句柄
        mnewHandle := frmSXCKNewList.Handle;
      end;
    121:  //坯布出库
      begin
        if frmSXCKOutList = nil then
        begin
          frmSXCKOutList := TfrmSXCKOutList.Create(application.MainForm);
          with frmSXCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSXCKOutList.BringToFront;
       //句柄
        mnewHandle := frmSXCKOutList.Handle;
      end;
    131:  //坯布库存
      begin
        if frmPBCKKCList = nil then
        begin
          frmPBCKKCList := TfrmPBCKKCList.Create(application.MainForm);
          with frmPBCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBCKKCList.BringToFront;
       //句柄
        mnewHandle := frmPBCKKCList.Handle;
      end;
    132:  //坯布汇总仓库
      begin
        if frmPBCKKCHZList3 = nil then
        begin
          frmPBCKKCHZList3 := TfrmPBCKKCHZList3.Create(application.MainForm);
          with frmPBCKKCHZList3 do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBCKKCHZList3.BringToFront;
       //句柄
        mnewHandle := frmPBCKKCHZList3.Handle;
      end;
    211:  //外加工入库
      begin
        if frmWJGMDList = nil then
        begin
          frmWJGMDList := TfrmWJGMDList.Create(application.MainForm);
          with frmWJGMDList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGMDList.BringToFront;
       //句柄
        mnewHandle := frmWJGMDList.Handle;
      end;
    221:  //外加工出库
      begin
        if frmWJGCKOutList = nil then
        begin
          frmWJGCKOutList := TfrmWJGCKOutList.Create(application.MainForm);
          with frmWJGCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGCKOutList.BringToFront;
       //句柄
        mnewHandle := frmWJGCKOutList.Handle;
      end;
    231:  //外加工库存
      begin
        if frmWJGCKKCList = nil then
        begin
          frmWJGCKKCList := TfrmWJGCKKCList.Create(application.MainForm);
          with frmWJGCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGCKKCList.BringToFront;
       //句柄
        mnewHandle := frmWJGCKKCList.Handle;
      end;

//    232:  //外加工库存汇总
//      begin
//        if frmWJGCKKCHZList = nil then
//        begin
//          frmWJGCKKCHZList := TfrmWJGCKKCHZList.Create(application.MainForm);
//          with frmWJGCKKCHZList do
//          begin
//            caption := Trim(Title);
//            FormStyle := mstyle;
//            windowState := mstate;
//            BorderStyle := mborderstyle;
//           //show;
//          end;
//        end
//        else
//          frmWJGCKKCHZList.BringToFront;
//       //句柄
//        mnewHandle := frmWJGCKKCHZList.Handle;
//      end;
      233:  //外加工库存汇总列表
      begin
        if frmDJBCKKCHZList2 = nil then
        begin
          frmDJBCKKCHZList2 := TfrmDJBCKKCHZList2.Create(application.MainForm);
          with frmDJBCKKCHZList2 do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKKCHZList2.BringToFront;
       //句柄
        mnewHandle := frmDJBCKKCHZList2.Handle;
      end;
    411:  //回仓录入
      begin
        if frmDJBRKList2 = nil then
        begin
          frmDJBRKList2 := TfrmDJBRKList2.Create(application.MainForm);
          with frmDJBRKList2 do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBRKList2.BringToFront;
       //句柄
        mnewHandle := frmDJBRKList2.Handle;
      end;

    311:  //成品入库列表
      begin
        if frmDJBRKList = nil then
        begin
          frmDJBRKList := TfrmDJBRKList.Create(application.MainForm);
          with frmDJBRKList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBRKList.BringToFront;
       //句柄
        mnewHandle := frmDJBRKList.Handle;
      end;
    321:  //成品出库列表
      begin
        if frmDJBCKOutList = nil then
        begin
          frmDJBCKOutList := TfrmDJBCKOutList.Create(application.MainForm);
          with frmDJBCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKOutList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKOutList.Handle;
      end;
    331:  //成品库存列表
      begin
        if frmDJBCKKCList = nil then
        begin
          frmDJBCKKCList := TfrmDJBCKKCList.Create(application.MainForm);
          with frmDJBCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKKCList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKKCList.Handle;
      end;
    332:  //成品汇总库存列表
      begin
        if frmDJBCKKCHZList = nil then
        begin
          frmDJBCKKCHZList := TfrmDJBCKKCHZList.Create(application.MainForm);
          with frmDJBCKKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKKCHZList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKKCHZList.Handle;
      end;
    333:  //成品库存流水表
      begin
        if frmCKProductBSCRCList = nil then
        begin
          frmCKProductBSCRCList := TfrmCKProductBSCRCList.Create(application.MainForm);
          with frmCKProductBSCRCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBSCRCList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBSCRCList.Handle;
      end;

  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_PBMDDJ) then
    DataLink_PBMDDJ := TDataLink_PBMDDJ.Create(Application);
  try
    with DataLink_PBMDDJ.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_PBMDDJ.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_PBMDDJ.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

